#include "Body.h"

/**
 * @brief TODO
 */
Body::Body( const char *meshPath )
    : m_mesh( meshPath )
{
    generateSepPlanesBuffers();
}

Body::~Body()
{
    glDeleteVertexArrays(1, &m_sepPlanes_vao);
    glDeleteBuffers(1, &m_sepPlanes_vbo);
    glDeleteBuffers(1, &m_sepPlanes_ebo);
}

void Body::generateSepPlanesBuffers()
{
    // *** Plane Buffers ***

    glGenBuffers(1, &m_sepPlanes_vbo);
    glGenBuffers(1, &m_sepPlanes_ebo);
    glGenVertexArrays(1, &m_sepPlanes_vao);
    glBindVertexArray(m_sepPlanes_vao);

    static const int indices[] = { 0, 1, 2, 3, 4, 5, 6 };
    static const glm::vec3 vertices[4] = { glm::vec3(0), glm::vec3(0), glm::vec3(0), glm::vec3(0) };

    glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, m_sepPlanes_ebo);
    glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(indices), indices, GL_STATIC_DRAW);

    glBindBuffer(GL_ARRAY_BUFFER, m_sepPlanes_vbo);
    glBufferData(GL_ARRAY_BUFFER, sizeof(vertices), vertices, GL_STATIC_DRAW);

    glVertexAttribPointer(0, 3, GL_FLOAT, GL_FALSE, sizeof(glm::vec3), (void*)0);
    glEnableVertexAttribArray(0);

    glBindBuffer(GL_ARRAY_BUFFER, 0);
    glBindVertexArray(0);

}

/**
 * @brief TODO
 */
void Body::render( Shader &shader )
{
    shader.bind();

    // Transform all vertices to world space based on the current
    // model to world matrix.
    shader.setUniform( "model", m_modelToWorld );

    // The fragment shader determines the fragment color based on
    // lighting and object color.
    shader.setUniform( "objectColor", m_color );

    m_mesh.render(shader);
}
